# coding: utf-8

"""
    symbl.ai APIs

    <h1>Symbl's APIs for external consumers.</h1> <h2>Language Insights API</h2> Symbl's Language Insights API provides an interface for applications to perform the analysis on the raw text and get insights from it. The API automatically detects sentence boundaries and punctuates the sentences, and also returns the updated messages in the response. Conversations are the most unstructured piece of information that we represent information in, and which most of the leads to lot of loss of information by not being able to capture them correctly.<br/> Language Insights API focuses on understanding such texts and generate the useful and important information from them. <br/> Currently the API supports detection of the Action Items in any type of unstructured text. In future the same API will also have support to detect \"Information\" and \"Event\", where Information is any informational piece and Event is a reference to something that has happened in the past.<br/> <h2>Telephony Integration</h2> Symbl can currently integrate with two types of telephony endpoints: 1. SIP trunks<br/> 2. PSTN endpoints<br/> Results are sent via HTTP WebHooks as and when they are available.<br/> <h2>Flow</h2> 1. External Application invokes REST API to join a meeting/session, with the mode (SIP/PSTN) and joining details<br/> 2. Symbl joins the meeting via SIP or PSTN integration<br/> 3. Symbl continuously processes the audio stream received<br/> 4. Symbl calls WebHook whenever transcription results are available<br/>  # noqa: E501

    OpenAPI spec version: 0.0.1
    Contact: info@symbl.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Action(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'invoke_on': 'str',
        'name': 'str',
        'parameters': 'object'
    }

    attribute_map = {
        'invoke_on': 'invokeOn',
        'name': 'name',
        'parameters': 'parameters'
    }

    def __init__(self, invoke_on=None, name=None, parameters=None):  # noqa: E501
        """Action - a model defined in Swagger"""  # noqa: E501
        self._invoke_on = None
        self._name = None
        self._parameters = None
        self.discriminator = None
        self.invoke_on = invoke_on
        self.name = name
        if parameters is not None:
            self.parameters = parameters

    @property
    def invoke_on(self):
        """Gets the invoke_on of this Action.  # noqa: E501

        event type on which the action should be performed  # noqa: E501

        :return: The invoke_on of this Action.  # noqa: E501
        :rtype: str
        """
        return self._invoke_on

    @invoke_on.setter
    def invoke_on(self, invoke_on):
        """Sets the invoke_on of this Action.

        event type on which the action should be performed  # noqa: E501

        :param invoke_on: The invoke_on of this Action.  # noqa: E501
        :type: str
        """
        if invoke_on is None:
            raise ValueError("Invalid value for `invoke_on`, must not be `None`")  # noqa: E501
        allowed_values = ["start", "stop"]  # noqa: E501
        if invoke_on not in allowed_values:
            raise ValueError(
                "Invalid value for `invoke_on` ({0}), must be one of {1}"  # noqa: E501
                .format(invoke_on, allowed_values)
            )

        self._invoke_on = invoke_on

    @property
    def name(self):
        """Gets the name of this Action.  # noqa: E501

        Name of the action that needs to be invoked  # noqa: E501

        :return: The name of this Action.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Action.

        Name of the action that needs to be invoked  # noqa: E501

        :param name: The name of this Action.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def parameters(self):
        """Gets the parameters of this Action.  # noqa: E501

        object with required input parameter data for invocation of the specified action  # noqa: E501

        :return: The parameters of this Action.  # noqa: E501
        :rtype: object
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this Action.

        object with required input parameter data for invocation of the specified action  # noqa: E501

        :param parameters: The parameters of this Action.  # noqa: E501
        :type: object
        """

        self._parameters = parameters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Action, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Action):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
